package mhtree;

/**
 * Specifies how should new objects be added to the MH-Tree.
 */
public enum InsertType {
    /**
     * When inserted object is not covered by node, all objects under such node are retrieved and a new hull is build,
     * replacing the current one.
     */
    GREEDY,

    /**
     * When inserted object is not overed by node, we iterate over hull objects beginning with the nearest hull object.
     * We try to replace existing hull object by replacing current hull object by inserted object
     * and checking if the replaced hull objects is covered by the new hull.
     * This is repeated until such hull object is found or if not,
     * the inserted object is simply added as a new hull object.
     */
    INCREMENTAL,
}
