package mhtree;

import messif.objects.LocalAbstractObject;

public class ObjectToNodeDistanceRank implements Comparable<ObjectToNodeDistanceRank> {

    private final Node node;
    private final LocalAbstractObject object;
    private final double distance;

    public ObjectToNodeDistanceRank(LocalAbstractObject object, Node node) {
        this.node = node;
        this.object = object;
        this.distance = node.getDistance(object);
    }

    public int compareTo(ObjectToNodeDistanceRank rank) {
        return Double.compare(distance, rank.node.getDistance(object));
    }

    public Node getNode() {
        return node;
    }
}
