package mhtree.benchmarking;

import messif.objects.LocalAbstractObject;
import mhtree.InsertType;

import java.util.List;

public class MHTreeConfig {
    private final int leafCapacity;
    private final int numberOfChildren;
    private final int numberOfThreads;
    private final InsertType insertType;
    private List<LocalAbstractObject> objects;

    MHTreeConfig(int leafCapacity, int numberOfChildren, int numberOfThreads, InsertType insertType) {
        this.leafCapacity = leafCapacity;
        this.numberOfChildren = numberOfChildren;
        this.numberOfThreads = numberOfThreads;
        this.insertType = insertType;
    }

    public void setObjects(List<LocalAbstractObject> objects) {
        this.objects = objects;
    }

    public List<LocalAbstractObject> getObjects() {
        return objects;
    }

    public int getLeafCapacity() {
        return leafCapacity;
    }

    public int getNumberOfChildren() {
        return numberOfChildren;
    }

    public int getNumberOfThreads() {
        return numberOfThreads;
    }

    public InsertType getInsertType() {
        return insertType;
    }

    @Override
    public String toString() {
        return "MHTreeConfig{" +
                "leafCapacity=" + leafCapacity +
                ", numberOfChildren=" + numberOfChildren +
                ", numberOfThreads=" + numberOfThreads +
                ", insertType=" + insertType +
                '}';
    }
}
